#
# Colors.tcl   :   hsv to rgb conversion, etc.
# 
#
# by zhuo     http://www.geocities/cl/zhuoware
#
# Rev. 0.01 May 18, 2008 
#

# should use namespace.... in future.

#convert rgb.  0.0-1.0 to colorcode string #ffe030
#
proc Colors_rgbToColorCode { rgblist } {
    set r [lindex $rgblist 0]
    set g [lindex $rgblist 1]
    set b [lindex $rgblist 2]
#    cPuts $rgblist
    return [format "\#%02x%02x%02x" [expr int($r*255.0)] [expr int($g*255.0)] [expr int($b*255.0)]]
}

#return list {r g b} , each 0.0-1.0
# h:  0-360.0,   s,v: 0.0-1.0
proc Colors_hsvToRgb { h s v } {
    if { $s == 0 } {
	return [list $v $v $v]
    }
    set hi [expr int($h / 60.0) ]
    set f [expr $h / 60.0 - $hi]
    set m [expr $v * (1.0 - $s)]
    set n [expr $v * (1.0 - $f * $s)]
    set k [expr $v * (1.0 - (1.0-$f) * $s)]
    if { $hi == 0 } {
	return [list $v $k $m]
    }
    if { $hi == 1 } {
	return [list $n $v $m]
    } 
    if { $hi == 2 } {
	return [list $m $v $k]
    }
    if { $hi == 3 } {
	return [list $m $n $v]
    }
    if { $hi == 4 } {
	return [list $k $m $v]
    }
    if { $hi == 5 } {
	return [list $v $m $n]
    }
    return [list 1.0 1.0 1.0]
}